  var DEFAULT_TITLE = "<i>Click to select, click again to open photo</i>";
  var current = null;
  var landscape = true;
  var mapShown = false;
  var firstStart = true;
  var currentMarker = null;
  var markers = new Array();
	    
  function locatorSetup() {
    setupMap();
    $("Locator").style.visibility = "visible";  
    $("Loading").style.display = "none";
  }
  
  function setupMap() {
    if (GBrowserIsCompatible()) {
       map = new GMap2(document.getElementById("Map"), {
         mapTypes : G_DEFAULT_MAP_TYPES
       });
       map.setCenter(new GLatLng(settings.lat, settings.lng), settings.zoom);
       map.addControl(new GSmallMapControl());
       map.addControl(new GMapTypeControl());
       //map.addControl(new GOverviewMapControl());
       var opts = new Object();
       opts.title = "Current Location";
       currentMarker = new GMarker(new GLatLng(settings.lat, settings.lng));
       map.addOverlay(currentMarker);
       currentMarker.hide();
       getPhotos();
       
       GEvent.addListener(map, "click", function(marker, point) {
         if (marker) {
           if (marker.img) {
             selectThumb(marker.img);
           };
         }
         else {
           settings.lat = point.lat();
           settings.lng = point.lng();
           settings.zoom = map.getZoom();         
           map.panTo(new GLatLng(settings.lat, settings.lng));
           getPhotos();
           saveSettings();
         }  
       });       
    }  
  }
  
  function getPhotos() {
    settings.lat = map.getCenter().lat();
    settings.lng = map.getCenter().lng();
    settings.zoom = map.getZoom();         
    saveSettings();
    hidePhoto();
    var bounds = map.getBounds();
    $("Photos").innerHTML = "";
    current = null;
    $("PhotosTitle").innerHTML = "<img src='loading.gif'> Loading...";
    currentMarker.hide();
    for (var i = 0; i < markers.length; i++) {
    	map.removeOverlay(markers[i]);
    }
    markers = new Array();
    var head = document.getElementsByTagName("head")[0];
    var script = $("PanoCode");
    if (script) {
      head.removeChild(script);
    }
    script = document.createElement("script");
    script.id = "PanoCode";
    var minx = bounds.getSouthWest().lng();
    var maxx = bounds.getNorthEast().lng();
    var miny = bounds.getSouthWest().lat();
    var maxy = bounds.getNorthEast().lat();
    script.src = "http://www.panoramio.com/map/get_panoramas.php?callback=setPhotos" +
        "&order=" + $("OrderSelect").value +
        "&set=" + $("TypeSelect").value +
        "&from=0&to=12" +
        "&minx=" + minx +
        "&miny=" + miny +
        "&maxx=" + maxx +
        "&maxy=" + maxy +
        "&size=square";
    head.appendChild(script);
  }
  
  function setPhotos(photos) {
    $("PhotosTitle").innerHTML = DEFAULT_TITLE;
    var first = null;
    var next = null;
    for (var i = 0; i < photos.photos.length; i++) {
    	var photo = photos.photos[i];
    	var img = document.createElement("img");
    	img.src = photo.photo_file_url;
    	img.className = "thumb";
    	$("Photos").appendChild(img);
    	img.photo = photo;
      var blueIcon = new GIcon(G_DEFAULT_ICON);
      blueIcon.image = "http://www.google.com/intl/en_us/mapfiles/ms/micons/blue-dot.png";
    	var marker = new GMarker(new GLatLng(photo.latitude, photo.longitude), { icon:blueIcon });
      map.addOverlay(marker);
      markers.push(marker);
      marker.img = img;
    	
    	img.next = next;
    	next = img;
    	if (i == 0) {
    	  first = img;
    	}
    	
    	img.onclick = function() {
  	    selectThumb(this);
    	}
    	
    	img.onmouseover = function() {
    	  $("PhotosTitle").innerHTML = "<i>" + this.photo.photo_title + "</i>";
    	}
    	img.onmouseout = function() {
    	  if (current) {
    	    $("PhotosTitle").innerHTML = current.photo.photo_title;
    	  }
    	  else {
          $("PhotosTitle").innerHTML = DEFAULT_TITLE;    	    
    	  }  
    	}
    }
    first.next = next;
    map.removeOverlay(currentMarker);
    map.addOverlay(currentMarker);
    currentMarker.hide();
  }
  
  function selectThumb(img) {
    $("PhotosTitle").innerHTML = img.photo.photo_title;
    $("PhotoOwner").innerHTML = "author: " + img.photo.owner_name;
    $("PhotoOwner").href = "javascript:widget.openURL('" + img.photo.owner_url + "')";
    $("PhotoLink").href = "javascript:widget.openURL('" + img.photo.photo_url + "')";
    var src = img.src.replace(/square/, "medium");    	  
    var bigimg = new Image();
    bigimg.src = src;
    bigimg.onload = function() {      
      $("PhotoImage").src = src;
      if (246 * bigimg.height / bigimg.width <= 175) {
        $("PhotoImage").width = 246;
        $("PhotoImage").height = 246 * bigimg.height / bigimg.width;        
      }
      else {
        $("PhotoImage").width = 175 * bigimg.width / bigimg.height;        
        $("PhotoImage").height = 175;        
      }      
    }
	  if (img == current) {
	    showPhoto();
	  }
	  else {
      if (current != null) {
        current.className = "thumb";
      }
      current = img;
      current.className = "thumb thumbSelected";
      currentMarker.setLatLng(new GLatLng(current.photo.latitude, current.photo.longitude));
      currentMarker.show();
      currentMarker.img = img;
      $("PhotosTitle").innerHTML = current.photo.photo_title;    
	  }  
  }
  
  function nextPhoto() {
    if (current) {
      selectThumb(current.next);
      selectThumb(current);
      showPhoto();
    }
  }
  
  function showPhoto() {
    $("Photo").style.display = "block";
    $("Photos").style.display = "none";
  }
  
  function hidePhoto() {
    $("Photo").style.display = "none";
    $("Photos").style.display = "block";
  }
  
  function $(id) {
    return document.getElementById(id);
  } 
   
  function debug(msg) {
    var e = document.getElementById("Debug");
    e.innerHTML += msg + "<br>";
  }
