var settings = {
  lat: 45,
  lng: -getTimezoneOffset(new Date()) / 12 / 60 * 180,
  zoom: 2
}

function setup() {
  if (window.widget) {
    widgetSetup();
    readPrefs();
    widget.onremove = clearPrefs;
    widget.onshow = onshow;
    widget.onhide = onhide;
    if (widget.context) {
      document.getElementById("Widgetop").style.display = "none";
    }
    locatorSetup();
  }
}

function readPrefs() {
  if (window.widget) {
    var value = widget.preferenceForKey(widget.identifier + "-lat");
    if (value) {
      settings.lat = parseFloat(value);
    }
    var value = widget.preferenceForKey(widget.identifier + "-lng");
    if (value) {
      settings.lng = parseFloat(value);
    }
    var value = widget.preferenceForKey(widget.identifier + "-zoom");
    if (value) {
      settings.zoom = parseInt(value);
    }
    var value = widget.preferenceForKey(widget.identifier + "-order");
    if (value) {
      $("OrderSelect").value = value;
    }
    var value = widget.preferenceForKey(widget.identifier + "-type");
    if (value) {
      $("TypeSelect").value = value;
    }
  }
}

function clearPrefs() {
  widget.setPreferenceForKey(null, widget.identifier + "-lat");
  widget.setPreferenceForKey(null, widget.identifier + "-lng");
  widget.setPreferenceForKey(null, widget.identifier + "-zoom");
  widget.setPreferenceForKey(null, widget.identifier + "-order");
  widget.setPreferenceForKey(null, widget.identifier + "-type");
}

function saveSettings() {
  widget.setPreferenceForKey(settings.lat, widget.identifier + "-lat");
  widget.setPreferenceForKey(settings.lng, widget.identifier + "-lng");
  widget.setPreferenceForKey(settings.zoom, widget.identifier + "-zoom");
  widget.setPreferenceForKey($("OrderSelect").value, widget.identifier + "-order");
  widget.setPreferenceForKey($("TypeSelect").value, widget.identifier + "-type");
}
  
function onshow() {
}

function onhide() {
}

function widgetSetup() {
  if (window.widget) {
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
  	var gHelpButton = new AppleGlassButton(document.getElementById("HelpButton"), 
  	                                      "Help", showHelp); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "white", "black", showBack);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    saveSettings();
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function showHelp() {
  $("Help").style.display = "block";
}

function hideHelp() {
  $("Help").style.display = "none";
}

function getTimezoneOffset(date) {
  var offset = date.getTimezoneOffset();
  var diff = -(date.getHours() - date.getUTCHours()) * 60;
  if (Math.abs(diff) != Math.abs(offset)) {
    if (diff > 0) {
      diff -= 24 * 60;
    }
    else {
      diff += 24 * 60;
    }  
  }
  if (diff != offset) {
    offset = -offset;
  }
  return offset;
}
  
function $(id) {
  return document.getElementById(id);
}

if (top.myBrowser && top.myBrowser.needsXMLHttpRequestVariable) {var XMLHttpRequest;}